﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Data.OleDb;
using C1.Win.C1FlexGrid;
using System.Net;
using System.Net.Mail;
using C1.Win.C1Chart;
using C1.C1Schedule;
using C1.Win.C1Schedule;
using C1.C1Schedule;

namespace Assistant
{   
    public partial class Main : Form
    {
        MyMessageBox mmb;
        OleDbDataAdapter da, da1;
        DataSet ds;
        public Main()
        {
            InitializeComponent();
        }

        private void closeLabel_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void minLabel_Click(object sender, EventArgs e)
        {
            this.WindowState = FormWindowState.Minimized;
        }

        private void closeLabel_MouseEnter(object sender, EventArgs e)
        {
            closeLabel.Font = new Font(closeLabel.Font.FontFamily, 33);
        }

        private void closeLabel_MouseLeave(object sender, EventArgs e)
        {
            closeLabel.Font = new Font(closeLabel.Font.FontFamily, 30);
        }

        private void minLabel_MouseEnter(object sender, EventArgs e)
        {
            minLabel.Font = new Font(minLabel.Font.FontFamily, 33);
        }

        private void minLabel_MouseLeave(object sender, EventArgs e)
        {
            minLabel.Font = new Font(minLabel.Font.FontFamily, 30);
        }

        private void clockTimer_Tick(object sender, EventArgs e)
        {
            timeLabel.Text = DateTime.Now.ToShortDateString() + "     " + DateTime.Now.ToShortTimeString();
        }

        string con;
        private void Main_Load(object sender, EventArgs e)
        {
            // TODO: This line of code loads data into the 'assistantDataSet.Contacts' table. You can move, or remove it, as needed.
            this.contactsTableAdapter.Fill(this.assistantDataSet.Contacts);
            // TODO: This line of code loads data into the 'assistantDataSet.Contacts' table. You can move, or remove it, as needed.
            this.contactsTableAdapter.Fill(this.assistantDataSet.Contacts);
            birthTextBox.MaxDate = DateTime.Now.Date;

            mmb = new MyMessageBox();
            timeLabel.Text = DateTime.Now.ToShortDateString() + "     " + DateTime.Now.ToShortTimeString();

            ds = new DataSet();
            con = "Provider=Microsoft.Ace.OLEDB.12.0; Data Source=" + @"..\..\DataBase\Assistant.mdb";
            //da = new OleDbDataAdapter("select * from Contacts", con);
            ds.Tables.Add(assistantDataSet.Contacts.Copy());
            //da.Fill(ds, "Contacts");
            ds.Tables[0].TableName = "Contacts";
            ds.Tables[0].PrimaryKey = new DataColumn[] { ds.Tables[0].Columns[0] };
            contactsFlexGrid.DataSource = new DataView(ds.Tables[0]).ToTable(false, new string[] { "ID", "Contact_Name", "Phone_Number" });
            contactsFlexGrid.Cols[1].Visible = false;

            da1 = new OleDbDataAdapter("select * from Project", con);
            da1.Fill(ds, "Project");
            foreach (Column col in contactsFlexGrid.Cols)
                col.TextAlign = TextAlignEnum.CenterCenter;
        }

        HitTestInfo h;
        string id;
        DataRow dRow;
        private void contactsFlexGrid_MouseClick(object sender, MouseEventArgs e)
        {
            h = contactsFlexGrid.HitTest(e.Location);
            if (h.Type == HitTestTypeEnum.Cell || h.Type == HitTestTypeEnum.RowHeader)
            {
                if (h.Row > 0 && h.Row < contactsFlexGrid.Rows.Count)
                {
                    if (h.Column >= 0 && h.Column < contactsFlexGrid.Cols.Count)
                    {
                        saveButton.Visible = false;
                        conAddLabel.Visible = true;
                        conBirthLabel.Visible = true;
                        conCatLabel.Visible = true;
                        conEmailLabel.Visible = true;
                        conNameLabel.Visible = true;
                        conPhLabel.Visible = true;
                        contactHeadingLabel.Visible = true;
                        nameTextBox.Visible = true;
                        phTextBox.Visible = true;
                        addTextBox.Visible = true;
                        birthTextBox.Visible = true;
                        emailTextBox.Visible = true;
                        catTextBox.Visible = true;
                        nameTextBox.Enabled = false;
                        phTextBox.Enabled = false;
                        addTextBox.Enabled = false;
                        birthTextBox.Enabled = false;
                        emailTextBox.Enabled = false;
                        catTextBox.Enabled = false;
                        id = contactsFlexGrid[h.Row, 1].ToString();
                        dRow = ds.Tables[0].Rows.Find(id);
                        nameTextBox.Text = dRow.ItemArray[1].ToString();
                        phTextBox.Text = dRow.ItemArray[2].ToString();
                        addTextBox.Text = dRow.ItemArray[3].ToString();
                        birthTextBox.Value = Convert.ToDateTime(dRow.ItemArray[4]);
                        emailTextBox.Text = dRow.ItemArray[5].ToString();
                        catTextBox.Text = dRow.ItemArray[6].ToString();
                        sendMessageButton.Visible = true;
                    }
                }
            }            
        }

        bool add = false;
        private void editContactButton_Click(object sender, EventArgs e)
        {
            saveButton.Enabled = true;
            sendMessageButton.Visible = false;
            add = false;
            if (nameTextBox.Text == "" || phTextBox.Text == "" || addTextBox.Text == "" || birthTextBox.Text == "" || emailTextBox.Text == "" || catTextBox.Text == "")
            {
                mmb.BackColor = splitContainer1.Panel2.BackColor;
                mmb.MsgText = "Please select a contact to edit.";
                mmb.ShowDialog();                 
            }
            else
            {
                saveButton.Visible = true;
                conAddLabel.Visible = true;
                conBirthLabel.Visible = true;
                conCatLabel.Visible = true;
                conEmailLabel.Visible = true;
                conNameLabel.Visible = true;
                conPhLabel.Visible = true;
                contactHeadingLabel.Visible = true;
                nameTextBox.Visible = true;
                phTextBox.Visible = true;
                addTextBox.Visible = true;
                birthTextBox.Visible = true;
                emailTextBox.Visible = true;
                catTextBox.Visible = true;
                nameTextBox.Enabled = true;
                phTextBox.Enabled = true;
                addTextBox.Enabled = true;
                birthTextBox.Enabled = true;
                emailTextBox.Enabled = true;
                catTextBox.Enabled = true;
            }
        }

        OleDbCommandBuilder cb;
        private void saveButton_Click(object sender, EventArgs e)
        {
            if (nameTextBox.Text != string.Empty && phTextBox.Text != string.Empty && addTextBox.Text != string.Empty && emailTextBox.Text != string.Empty)
            {
                nameTextBox.Enabled = false;
                phTextBox.Enabled = false;
                addTextBox.Enabled = false;
                birthTextBox.Enabled = false;
                emailTextBox.Enabled = false;
                catTextBox.Enabled = false;
                saveButton.Enabled = false;
                if (add == false)
                {
                    dRow.ItemArray = new object[] { dRow.ItemArray[0], nameTextBox.Text, phTextBox.Text, addTextBox.Text, birthTextBox.Text, emailTextBox.Text, catTextBox.Text };
                }
                else
                    ds.Tables[0].Rows.Add(new object[] { Convert.ToInt32(ds.Tables[0].Rows[ds.Tables[0].Rows.Count - 1].ItemArray[0]) + 1, nameTextBox.Text, phTextBox.Text, addTextBox.Text, Convert.ToDateTime(birthTextBox.Text), emailTextBox.Text, catTextBox.Text });
                try
                {
                    cb = new OleDbCommandBuilder(da);
                    da.UpdateCommand = cb.GetUpdateCommand();
                    da.Update(ds.Tables[0]);
                    mmb.BackColor = splitContainer1.Panel2.BackColor;
                    mmb.MsgText = "Contact Saved Successfully.";
                    mmb.ShowDialog();
                    contactsFlexGrid.DataSource = new DataView(ds.Tables[0]).ToTable(false, new string[] { "ID", "Contact_Name", "Phone_Number" });
                    contactsFlexGrid.Cols[1].Visible = false;
                    sendMessageButton.Visible = true;
                }
                catch (Exception ex)
                {
                    mmb.BackColor = splitContainer1.Panel2.BackColor;
                    mmb.MsgText = "Contact is not saved.\nPlease Try Again.";
                    mmb.ShowDialog();
                }
            }
            else
            {
                mmb.MsgText = "Please Fill All Details.";
                mmb.ShowDialog();
            }
        }

        private void addContactButton_Click(object sender, EventArgs e)
        {
            saveButton.Enabled = true;
            saveButton.Visible = true;
            conAddLabel.Visible = true;
            conBirthLabel.Visible = true;
            conCatLabel.Visible = true;
            conEmailLabel.Visible = true;
            conNameLabel.Visible = true;
            conPhLabel.Visible = true;
            contactHeadingLabel.Visible = true;
            sendMessageButton.Visible = false;
            nameTextBox.Visible = true;
            phTextBox.Visible = true;
            addTextBox.Visible = true;
            birthTextBox.Visible = true;
            emailTextBox.Visible = true;
            catTextBox.Visible = true;
            add = true;
            nameTextBox.Enabled = true;
            phTextBox.Enabled = true;
            addTextBox.Enabled = true;
            birthTextBox.Enabled = true;
            emailTextBox.Enabled = true;
            catTextBox.Enabled = true;
            nameTextBox.Text = "";
            phTextBox.Text = "";
            addTextBox.Text = "";
            birthTextBox.Value = Convert.ToDateTime(DateTime.Now.Date.ToShortDateString());
            emailTextBox.Text = "";
            catTextBox.Text = "";
        }

        SendEmail se;
        private void sendMessageButton_Click(object sender, EventArgs e)
        {
            se = new SendEmail(emailTextBox.Text, mmb);
            se.ShowDialog();           
        }

        private void phTextBox_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (char.IsDigit(e.KeyChar) || e.KeyChar == 8)
            { }
            else
                e.Handled = true;
        }

        private void emailTextBox_Leave(object sender, EventArgs e)
        {
            try
            {
                new MailAddress(emailTextBox.Text);
            }
            catch(Exception ex)
            {
                mmb.BackColor = splitContainer1.Panel2.BackColor;
                mmb.MsgText = "Invalid Email ID.";
                mmb.ShowDialog();                  
                emailTextBox.Focus();
            }
        }

        bool selectChart = false;
        private void completedProjButton_Click(object sender, EventArgs e)
        {
            selectChart = true;
            projectC1FlexGrid.DataSource = new DataView(ds.Tables[1], @"[Completed/Pending]=true", "", DataViewRowState.CurrentRows).ToTable();
            projectC1FlexGrid.Cols[1].Visible = false;
            projectC1FlexGrid.AutoSizeCols();

            c1Chart1.DataSource = new DataView(ds.Tables[1], @"[Completed/Pending]=true", "", DataViewRowState.CurrentRows).ToTable();
            pdButton.PerformClick();

            c1Chart1.SendToBack();

            editProjButton.Visible = false;
            saveProjButton.Visible = false;
        }

        private void pendingProjButton_Click(object sender, EventArgs e)
        {
            editProjButton.Visible = true;
            saveProjButton.Visible = true;
            selectChart = true;
            projectC1FlexGrid.DataSource = new DataView(ds.Tables[1], @"[Completed/Pending]=false", "", DataViewRowState.CurrentRows).ToTable();
            projectC1FlexGrid.Cols[1].Visible = false;
            projectC1FlexGrid.AutoSizeCols();
            c1Chart1.DataSource = new DataView(ds.Tables[1], @"[Completed/Pending]=false", "", DataViewRowState.CurrentRows).ToTable();
            pdButton.PerformClick();
            c1Chart1.SendToBack();
        }

        private void pdButton_Click(object sender, EventArgs e)
        {
            if (selectChart == true)
            {
                c1Chart1.ChartArea.AxisY.Text = "Dates";
                c1Chart1.ChartArea.AxisY.AnnoFormat = FormatEnum.DateShort;
                c1Chart1.ChartGroups[0].ChartData.SeriesList.Clear();
                c1Chart1.ChartGroups[0].ChartData.SeriesList.AddNewSeries();
                c1Chart1.ChartGroups[0].ChartData.SeriesList.AddNewSeries();
                c1Chart1.ChartGroups[0].ChartData.SeriesList[0].X.DataField = "Project_Name";
                c1Chart1.ChartGroups[0].ChartData.SeriesList[0].Y.DataField = "Start_Date";
                c1Chart1.ChartGroups[0].ChartData.SeriesList[1].X.DataField = "Project_Name";
                c1Chart1.ChartGroups[0].ChartData.SeriesList[1].Y.DataField = "End_Date";
                c1Chart1.ChartGroups[0].ChartData.SeriesList[0].Label = "Start Date";
                c1Chart1.ChartGroups[0].ChartData.SeriesList[1].Label = "End Date";
            }
            else
                mmb.MsgText = "Please select a chart data.";
            foreach (Column col in projectC1FlexGrid.Cols)
                col.TextAlign = TextAlignEnum.CenterCenter;
        }

        private void pcButton_Click(object sender, EventArgs e)
        {
            if (selectChart == true)
            {
                c1Chart1.ChartArea.AxisY.Text = "Cost";
                c1Chart1.ChartArea.AxisY.AnnoFormat = FormatEnum.NumericCurrency;
                c1Chart1.ChartGroups[0].ChartData.SeriesList.Clear();
                c1Chart1.ChartGroups[0].ChartData.SeriesList.AddNewSeries();
                c1Chart1.ChartGroups[0].ChartData.SeriesList.AddNewSeries();
                c1Chart1.ChartGroups[0].ChartData.SeriesList.AddNewSeries();
                c1Chart1.ChartGroups[0].ChartData.SeriesList[0].X.DataField = "Project_Name";
                c1Chart1.ChartGroups[0].ChartData.SeriesList[0].Y.DataField = "Budget_Alloted";
                c1Chart1.ChartGroups[0].ChartData.SeriesList[1].X.DataField = "Project_Name";
                c1Chart1.ChartGroups[0].ChartData.SeriesList[1].Y.DataField = "Actual_Cost";
                c1Chart1.ChartGroups[0].ChartData.SeriesList[2].X.DataField = "Project_Name";
                c1Chart1.ChartGroups[0].ChartData.SeriesList[2].Y.DataField = "Loss/Profit";
                c1Chart1.ChartGroups[0].ChartData.SeriesList[0].Label = "Budget Alloted";
                c1Chart1.ChartGroups[0].ChartData.SeriesList[1].Label = "Actual Cost";
                c1Chart1.ChartGroups[0].ChartData.SeriesList[2].Label = "Loss/Profit";                           
            }
            else
                mmb.MsgText = "Please select a chart data.";
            foreach (Column col in projectC1FlexGrid.Cols)
                col.TextAlign = TextAlignEnum.CenterCenter;           
        }

        AddNewProject anp;
        public string projName;
        public DateTime startDate;
        public int budget;
        private void newProjButton_Click(object sender, EventArgs e)
        {
            anp = new AddNewProject(this);
            anp.saveClick += anp_saveClick;    
            anp.ShowDialog();                    
        }

        void anp_saveClick(object sender, EventArgs e)
        {
            DateTime endDate = Convert.ToDateTime(null);
            ds.Tables[1].Rows.Add(new object[] { Convert.ToInt32(ds.Tables[1].Rows[ds.Tables[1].Rows.Count - 1].ItemArray[0]) + 1, projName, startDate, endDate, budget, DBNull.Value, DBNull.Value, false });
            try
            {                
                string comStr = "insert into Project([Project_Name],[Start_Date],[Budget_Alloted]) values(?,?,?)";
                string conStr = "Provider=Microsoft.Ace.OLEDB.12.0; Data Source=" + @"..\..\DataBase\Assistant.mdb";
                OleDbConnection con = new OleDbConnection(conStr);
                con.Open();
                OleDbCommand com = new OleDbCommand(comStr,con);
                OleDbParameter[] par = new OleDbParameter[3];
                par[0] = new OleDbParameter("Project_Name", projName);
                par[1] = new OleDbParameter("Start_Date", OleDbType.DBDate);
                par[1].Value = startDate;    
                par[2] = new OleDbParameter("Budget_Alloted", budget);                                
                com.Parameters.AddRange(par);
                com.ExecuteNonQuery();
                con.Close();
                mmb.BackColor = reportsTabPage.BackColor;
                mmb.MsgText = "Project Saved Successfully.";
                mmb.ShowDialog();                
                projectC1FlexGrid.DataSource = new DataView(ds.Tables[1], @"[Completed/Pending]=false", "", DataViewRowState.CurrentRows).ToTable();
                projectC1FlexGrid.Cols[1].Visible = false;
                projectC1FlexGrid.AutoSizeCols();
                c1Chart1.DataSource = new DataView(ds.Tables[1], @"[Completed/Pending]=false", "", DataViewRowState.CurrentRows).ToTable();
                pdButton.PerformClick();
                c1Chart1.SendToBack();
           }
            catch (Exception ex)
            {
                mmb.BackColor = reportsTabPage.BackColor;
                mmb.MsgText = "Project is not saved.\nPlease Try Again.";
                mmb.ShowDialog();                                
            }
        }

        private void phTextBox_Leave(object sender, EventArgs e)
        {
            if (phTextBox.Text.Length < 10)
            {
                mmb.BackColor = splitContainer1.Panel2.BackColor;
                mmb.MsgText = "Phone Number Must Have 10 Digits.";
                mmb.ShowDialog();
                phTextBox.Focus();
            }
        }

        AppointmentList al;
        Appointment[] appArr;
        DateTime[] dt;
        private void copyAppButton_Click(object sender, EventArgs e)
        {
            al = c1Schedule1.SelectedAppointments;
            appArr = new Appointment[al.Count];
            for (int i = 0; i < al.Count; i++)
            {
                appArr[i] = al[i].Copy();
            }
        }

        Appointment app;
        private void pasteAppButton_Click(object sender, EventArgs e)
        {
            int count = 0;            
                    dt = c1Schedule1.SelectedDates;
                
                if (dt.Length < appArr.Length)
                    count = dt.Length;
                else
                    count = appArr.Length;                                        
            if (dt != null && appArr != null)
            {
                for (int i = 0; i < count; i++)
                {
                    app = new Appointment();
                    app.Body = appArr[i].Body;
                    app.Subject = appArr[i].Subject;
                    app.Location = appArr[i].Location;
                    app.Start = new DateTime(dt[i].Year, dt[i].Month, dt[i].Day, appArr[i].Start.Hour, appArr[i].Start.Minute, appArr[i].Start.Second);
                    app.Duration = appArr[i].Duration;
                    app.BusyStatus = appArr[i].BusyStatus;
                    app.Label = appArr[i].Label;
                    c1Schedule1.DataStorage.AppointmentStorage.Appointments.Add(app);
                }
            }
        }

        private void editProjButton_Click(object sender, EventArgs e)
        {
            projectC1FlexGrid.AllowEditing = true;
            foreach(Column col in projectC1FlexGrid.Cols)
            {
                col.AllowEditing = true;
            }
            projectC1FlexGrid.Rows[0].AllowEditing = false;
        }

        private void saveProjButton_Click(object sender, EventArgs e)
        {
            projectC1FlexGrid.AllowEditing = false;

            ds.Tables.RemoveAt(1);
            da1 = new OleDbDataAdapter("select * from Project", con);
            da1.Fill(ds, "Project");
            foreach (Column col in contactsFlexGrid.Cols)
                col.TextAlign = TextAlignEnum.CenterCenter; 

            mmb.BackColor = reportsTabPage.BackColor;
            mmb.MsgText = "Project Updated Successfully.";
            mmb.ShowDialog();           

            pendingProjButton.PerformClick();
        }

        bool update = false;
        private void projectC1FlexGrid_AfterEdit(object sender, RowColEventArgs e)
        {
            if (Convert.ToBoolean(projectC1FlexGrid[e.Row, 8]) == true)
            {
                if (projectC1FlexGrid[e.Row, 2].ToString() == string.Empty || projectC1FlexGrid[e.Row, 3].ToString() == string.Empty || projectC1FlexGrid[e.Row, 4].ToString() == string.Empty || projectC1FlexGrid[e.Row, 5].ToString() == string.Empty || projectC1FlexGrid[e.Row, 6].ToString() == string.Empty || projectC1FlexGrid[e.Row, 7].ToString() == string.Empty)
                {
                    update = false;
                }
                else
                    update = true;
            }
            else
            {
                if (projectC1FlexGrid[e.Row, 2].ToString() == string.Empty || projectC1FlexGrid[e.Row, 3].ToString() == string.Empty || projectC1FlexGrid[e.Row, 4].ToString() != string.Empty || projectC1FlexGrid[e.Row, 5].ToString() == string.Empty || projectC1FlexGrid[e.Row, 6].ToString() != string.Empty || projectC1FlexGrid[e.Row, 7].ToString() != string.Empty)
                    update = false;
                else
                    update = true;
            }
            if(update == true)
            {
                try
                {
                    string comStr = "UPDATE Project SET [Project_Name] = ?, [Start_Date] = ?, [End_Date] = ?, [Budget_Alloted] = ?, [Actual_Cost] = ?, [Loss/Profit] = ?, [Completed/Pending] = ? Where [ID] = ?";
                    string conStr = "Provider=Microsoft.Ace.OLEDB.12.0; Data Source=" + @"..\..\DataBase\Assistant.mdb";
                    OleDbConnection con = new OleDbConnection(conStr);
                    con.Open();
                    OleDbCommand com = new OleDbCommand(comStr, con);
                    OleDbParameter[] par = new OleDbParameter[8];
                    par[0] = new OleDbParameter("@name", projectC1FlexGrid[e.Row, 2]);
                    par[1] = new OleDbParameter("@start", OleDbType.DBDate);
                    par[1].Value = projectC1FlexGrid[e.Row, 3];
                    par[2] = new OleDbParameter("@end", OleDbType.DBDate);
                    par[2].Value = projectC1FlexGrid[e.Row, 4];
                    par[3] = new OleDbParameter("@budget", projectC1FlexGrid[e.Row, 5]);
                    par[4] = new OleDbParameter("@cost", projectC1FlexGrid[e.Row, 6]);
                    par[5] = new OleDbParameter("@pl", projectC1FlexGrid[e.Row, 7]);
                    par[6] = new OleDbParameter("@cp", projectC1FlexGrid[e.Row, 8]);
                    par[7] = new OleDbParameter("@id", projectC1FlexGrid[e.Row, 1]);
                    com.Parameters.AddRange(par);
                    com.ExecuteNonQuery();
                    con.Close();
                }
                catch (Exception ex)
                {
                    mmb.MsgText = "Changes will not be saved. Please try again.";
                    mmb.ShowDialog();
                }
            }
        }

        private void deleteToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (contactsFlexGrid.Row > 0 && contactsFlexGrid.Row < contactsFlexGrid.Rows.Count)
            {
                ds.Tables[0].Rows.RemoveAt(contactsFlexGrid.Row - 1);                
                try
                {
                    string comStr = "DELETE FROM Contacts WHERE [ID] = ?";
                    string conStr = "Provider=Microsoft.Ace.OLEDB.12.0; Data Source=" + @"..\..\Assistant.mdb";
                    OleDbConnection con = new OleDbConnection(conStr);
                    con.Open();
                    OleDbCommand com = new OleDbCommand(comStr, con);
                    OleDbParameter par = new OleDbParameter("@ID", contactsFlexGrid[contactsFlexGrid.Row, 1]);
                    com.Parameters.Add(par);
                    com.ExecuteNonQuery();
                    con.Close();
                    contactsFlexGrid.DataSource = new DataView(ds.Tables[0]).ToTable(false, new string[] { "ID", "Contact_Name", "Phone_Number" });
                    contactsFlexGrid.Cols[1].Visible = false;
                    mmb.BackColor = splitContainer1.Panel2.BackColor;
                    mmb.MsgText = "Contact Deleted Successfully.";
                    mmb.ShowDialog();
                }
                catch (Exception ex)
                {
                    mmb.MsgText = "Changes will not be saved. Please try again.";
                    mmb.ShowDialog();
                }
            }
        }

        private void c1Schedule1_AppointmentAdded(object sender, AppointmentEventArgs e)
        {
           
            e.Appointment.Label = new C1.C1Schedule.Label(Color.LightPink, "Say Happy Birthday", "Happy Birthday");
            RecurrencePattern rp = e.Appointment.GetRecurrencePattern();
            rp.NoEndDate = true;
            rp.RecurrenceType = RecurrenceTypeEnum.Yearly;
            rp.DayOfMonth = e.Appointment.Start.Day;
            rp.MonthOfYear = e.Appointment.Start.Month;
            e.Appointment.ReminderSet = true;                     
        }

    
    }
}


