﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Assistant
{
    public partial class AddNewProject : Form
    {
        Main main;
        public event EventHandler saveClick;
        public AddNewProject(Main main)
        {
            InitializeComponent();
            this.main = main;            
        }

        private void closeLabel_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void saveButton_Click(object sender, EventArgs e)
        {            
            main.projName = nameTextBox.Text;
            main.startDate = startDateTimePicker.Value;
            main.budget = Convert.ToInt32(budgetTextBox.Text);
            if (saveClick != null)
                saveClick(this, e);
            Close();
        }

        private void budgetTextBox_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (char.IsDigit(e.KeyChar) || e.KeyChar == 8)
            { }
            else
                e.Handled = true;
        }
    }
}
